# Source Files

This directory contains the source files for the Tomo compiler:

- Abstract syntax trees: [ast.c](ast.c)/[ast.h](ast.h)
- Compilation: [compile.c](compile.c)/[compile.h](compile.h)
- Helper functions for Cords: [cordhelpers.c](cordhelpers.c)/[cordhelpers.h](cordhelpers.h)
- Compilation logic for enums: [enums.c](enums.c)/[enums.h](enums.h)
- Compilation environments: [environment.c](environment.c)/[environment.h](environment.h)
- Parsing: [parse.c](parse.c)/[parse.h](parse.h)
- A read-evaluate-print loop: [repl.c](repl.c)/[repl.h](repl.h)
- Compilation logic for structs: [structs.c](structs.c)/[structs.h](structs.h)
- The compiler executable: [tomo.c](tomo.c)/[tomo.h](tomo.h)
- Typechecking logic: [typecheck.c](typecheck.c)/[typecheck.h](typecheck.h)
- The datatype for representing Tomo types: [types.c](types.c)/[types.h](types.h)
